from .data_type import DataTypeField, DataTypeSchema
from .schema_version_checker import verify_schema_version
import marshmallow as ma


class EndpointOwner(ma.Schema):
    """
    Schema for processing the endpoint_owner#1.0.0 data type
    """

    _DATA_TYPE = "endpoint_owner#1.0.0"

    DATA_TYPE = DataTypeField(_DATA_TYPE)

    identity_id = ma.fields.UUID(
        required=True,
        description="Auth identity ID of the endpoint owner",
    )

    @ma.validates("DATA_TYPE")
    def validate_data_type(self, data, **kwargs):
        verify_schema_version(data, self._DATA_TYPE)


endpoint_owner_schema = EndpointOwner()

DataTypeSchema.register_schema(endpoint_owner_schema)
