import marshmallow as ma

from .data_type import DataTypeField, DataTypeSchema


class InvalidCredential(ma.Schema):
    """
    Error details when the caller's identity maps to an account with a user
    credential that is in an invalid state.
    """

    _DATA_TYPE = "invalid_credential#1.0.0"
    DATA_TYPE = DataTypeField(_DATA_TYPE)
    user_credential_id = ma.fields.UUID(
        required=True,
        description="""
        The ID of the user credential which needs to be fixed before this
        resource can be accessed.
        """,
    )


invalid_credential_schema = InvalidCredential()
DataTypeSchema.register_schema(invalid_credential_schema)
