import marshmallow as ma

from .data_type import DataTypeField, DataTypeSchema


class LimitExceeded(ma.Schema):
    """
    Error details when a user would be authorized, but the endpoint has reached
    a hard resource limit on the type of object being created.
    """

    _DATA_TYPE = "limit_exceeded#1.0.0"
    DATA_TYPE = DataTypeField(_DATA_TYPE)


limit_exceeded_schema = LimitExceeded()
DataTypeSchema.register_schema(limit_exceeded_schema)
