import marshmallow as ma

from .data_type import DataTypeField, DataTypeSchema


class SubscriptionRequired(ma.Schema):
    """
    Error details when the caller has attempted to access a feature
    not supported by the endpoint's subscription.
    """

    _DATA_TYPE = "subscription_required#1.0.0"
    DATA_TYPE = DataTypeField(_DATA_TYPE)
    subscription_level = ma.fields.String(
        description="Level of subscription required for this feature"
    )

    add_ons = ma.fields.List(
        ma.fields.String,
        description="List of subscription add-ons required for this feature",
    )


subscription_required_schema = SubscriptionRequired()
DataTypeSchema.register_schema(subscription_required_schema)
