import marshmallow as ma

from globus.manager.api.schemas.api.node import Node


class EndpointDomainSchema(ma.Schema):
    """
    DNS Domain for an Endpoint
    """

    _DATA_TYPE = "endpoint_domain#1.0.0"
    DATA_TYPE = ma.fields.Str(
        default=_DATA_TYPE, validate=[ma.validate.Equal(_DATA_TYPE)]
    )
    domain_name = ma.fields.String(validate=[ma.validate.Length(max=256)])
    nodes = ma.fields.List(ma.fields.Nested(Node))


endpoint_domain_schema = EndpointDomainSchema()
